"""
An illustration of how to retrieve the factors of
a symmetric (possibly indefinite) matrix as computed
by pyma27. Factors may be recovered in ll_mat format
for, e.g., modification, backsolves or display.
"""
import pyma27
from pysparse import spmatrix
import numpy
import sparsetools
from demo_ma27 import Ma27SpecSheet
import sys

(A, rhs) = Ma27SpecSheet()
n = A.shape[0]
P = pyma27.PyMa27Context( A )

print 'permutation = ', P.fetch_perm()
P.fetch_lb()
print ' L = '
print P.L
print ' B = '
print P.B


P.solve( rhs )
print 'solution = ', P.x

for prob in sys.argv[1:]:
    A = spmatrix.ll_mat_from_mtx( prob )
    sparsetools.spymatll( A )
    P = pyma27.PyMa27Context( A )
    P.fetch_lb()
    sparsetools.spymatll( P.L )


