import amplpy
from lbfgsm import LbfgsFramework
import sys

headerfmt = '%-15s  %-6s  %-5s  %-12s  %-12s  %-6s  %-7s\n'
header = headerfmt % ('Problem', 'n', 'pairs', 'Obj', 'Grad', 'Iter', 'Time')
hlen = len( header )
format =  '%-15s  %-6d  %-5d  %-12g  %-12g  %-6d  %-7g\n'
sys.stdout.write( header )
sys.stdout.write( '-' * hlen + '\n' )

for ProblemName in sys.argv[1:]:
    nlp = amplpy.AmplModel( ProblemName )

    for m in [1,2,3,4,5,10,15,20]:
        lbfgs = LbfgsFramework(nlp, npairs=m, scaling=True, silent=True)
        lbfgs.solve()

        # Output final statistics
        probname = ProblemName
        if probname[-3:] == '.nl': probname = probname[:-3]
        sys.stdout.write(format % (probname, nlp.n, lbfgs.npairs, lbfgs.f,
                                   lbfgs.gnorm, lbfgs.iter, lbfgs.tsolve))
        
    #nlp.writesol( lbfgs.x, nlp.pi0, 'And the winner is' )
    nlp.close()                              # Close connection with model
