#!/usr/bin/env python

# Read an nl file and output the sparsity
# pattern of the Hessian matrix at the
# starting point

import amplpy
import sparsetools as ST
import pylab
import sys

def usage():
    sys.stderr.write( 'Please specify a problem name\n' )
    sys.stderr.write( 'The problem should be an Ampl model or nl file\n' )
    sys.exit( -1 )

def plot_sparsity_pattern( nlp ):
    ax = ST.spymatll( nlp.hess( nlp.x0, nlp.pi0 ) )

if __name__ == '__main__':
    if len( sys.argv ) < 2: usage()
    nlp = amplpy.AmplModel( sys.argv[1] )
    plot_sparsity_pattern( nlp )
    nlp.close()
    pylab.show()
