"""
Implement the example from the GLTR spec sheet
"""
import pygltr
from pysparse import spmatrix
from nlpy_timing import cputime
from demo_pygltr import SpecSheet


radius = 10.0
(H, g) = SpecSheet()

# Preconditioner is 2 * Identity
def prec( v ):
    return 0.5 * v

G = pygltr.PyGltrContext( g, radius = radius ) #, prec = prec )
#G.debug = True
t = cputime()
(f, mult, snorm, niter, nc, ierr ) = G.explicit_solve( H.to_csr() )
t = cputime() - t
print ' f = ', f
print ' mult = ', mult
print ' step = ', G.step[:10]
print ' snorm = ', snorm
print ' niter = ', niter
print ' nc = ', nc
print ' ierr = ', ierr
print ' Solution time : %-gs' % t

